/*Script to process the contents of a Help DATA file to display selected pages and zserach for key words.
Created:	7/1/14
Updated:	8/1/14, 12/1/14, 13/1/14
 Philip Bolt, 2014. phb@redhall.org.uk. www.redhall.org.uk

Update	12/1/14, allow 'key' case to be changed and to select 'key' case insensitive. This required a change in the operation of 'un_lite' 
which now works by storing and replacing the whole section.
Check that a keyword has been entered before doing anything.

Update	13/1/14, Recognise any form of the key wor/phrase and replace with the same form only highlit.
*/
//Display & Back variables.
var str="v0";
var prev="v0";
var prev_hash="#top";
var str_hash="#top";
var mane;
//Checker variables.
var lft;
var s="v";
var t="t";
var sect;
var ttl;
var title;
var key="data";
var content;
var content_txt="";
var cnt=0;
//hilite variables
var str_s="v0";
var prev_s="v0";
var occ="";
var hi_pre = "<span style="+String.fromCharCode(34)+"background:#ffff80;"+String.fromCharCode(34)+">";
var hi_post = "</span>";

//Create the section codes array, ('0' is to ensure that item is defined by array subscript 1).
var itms=[0,1,3,4,5,6,7,8,9,10,11]
var nd=itms.length-1;

//Create the array for the ListBox items.
var lb=new Array(nd+1);
	for (var j=0; j<lb.length; j++)
		{
		var r_a_d= new Array(2);
		for (var k=0; k<r_a_d.length; k++)
			{
			r_a_d[k]="";	//Initialise with nulls.
			}
		lb[j]=r_a_d;
		}

/* Main display function.
Parameters:		dv;		the section code for display,
				hsh;	ID for a particular part of the section*/
function display(dv, hsh)
	{
	mane=document.getElementById("main").contentDocument
	prev=str;											//Store the 'Previous' section code and
	mane.getElementById(str).style.display = "none";	//hide the current display.
	str=dv;												//Store the requested area flag and
	mane.getElementById(dv).style.display = "block";	//display the section.
 
	if(hsh!==undefined && hsh!=="")	//If there is a location ID
		{						
		var hs = hsh;				//store the hash value				
		}
	else							//Otherwise,
		{
		var hs = "#"+dv;			//set it to jump to the top of the section.
		}
	mane.location.hash = hs;	//Jump.
	
	prev_hash=str_hash;			//Store the 'previous' hash value and
	str_hash=hs;				//the current value.
	
	if (prev!="v0")											//If there is a 'Previous' section.
		{
		mane.getElementById("bck").style.display = "block";	//display the 'Back' button.
		}
	}

//Function run when the 'Back' button is clicked.
function back()
	{
	display(prev,prev_hash);							//Display the 'Previous' section,
	mane.getElementById("bck").style.display = "none";	//hide the Back button.
	}
	
//Function run when the Content or Index file is unloaded.
function close()
	{
	mane.getElementById(str).style.display = "none";	//hide the current display.
	}

//Function to check for the existence of a KEY word or phrase in the various sections.
function checker()
	{
	mane=document.getElementById("main").contentDocument	//Store the contents of the two panes.
	lft=document.getElementById("left").contentDocument
	//Read the entered key word/s
	key=lft.getElementById("key").value
	if (key!="")	//Check that a key word was entered.
		{
		cnt=0;	//Zero the count of applicable sections.
		//Loop through the sections.
		for (var i = 1; i < nd+1; i++)
			{
			var cd=itms[i].toString();	//Create the section number code,
			sect=s+cd;					//the section and
			ttl=t+cd;					//title codes.
			title=mane.getElementById(ttl).innerHTML	//Store the Title of this section and
			content=mane.getElementById(sect)			//its contents.
			
			//Loop through the collection of paragraphs and check for the KEY text.
			var paras = content.getElementsByTagName('p');//the collection of <p> tags in this section.
			for(var j=0;j<paras.length;j++)
				{
				var txt=paras[j].innerHTML	//Store a paragraph.
				if(txt.match(new RegExp("\\b"+key+"\\b", 'i'))!=null)	//then the key is in this paragraph, so
					{
					cnt=cnt+1;			//increment the number of finds.
					lb[cnt][0]=title;	//store the section Title and 
					lb[cnt][1]=sect;	//its code in the array.
					j=paras.length		//Terminate the para. loop.
					}
				}
			}
	 
		if (cnt!=0)	//Some cases of the key have been found, so
			{
				//Populate the ListBox with the Titles from the array.
				var selkt = lft.getElementById("sel_list")	//Defined the Box variable and
				selkt.options.length = 0;					//clear any previous items.
				
				for ( var i = 0; i < lb.length; ++i )
				{ 
					selkt.options[i] = new Option(lb[i][0],lb[i][0]);
				}
			}
		else
			{
			//Display message " no instances of 'key' where found"
			lft.getElementById("key").value = "No instances of '"+key+"' were found.";
			}
		}
	}
	
//Function to highlight and display a selected section.
function hilite()
	{
	if(cnt!=0)	//Only act if some matches were found.
		{
		un_lite(prev_s);	//Remove any existing highlighting by restoring the precious section text.

		var idx=lft.getElementById("sel_list").selectedIndex	//Store the selected index and
		str_s=lb[idx][1];										//the corresponding section code.
	
		//Select the section required.
		mane=document.getElementById("main").contentWindow.document
		content=mane.getElementById(str_s)			//Store its contents and
		content_txt=content.innerHTML				//the text of the section.

		//Loop through the collection of paragraphs and check for the KEY text.
		var paras = content.getElementsByTagName('p');	//the collection of <p> tags in this section.

		for(var j=0;j<paras.length;j++)
			{
			var txt=paras[j].innerHTML							//Store the paragraph text.
			occ=txt.match(new RegExp("\\b"+key+"\\b", 'gi'));	//Create an array of occurrences of any form of the key as a complete word/phrase.
			if (occ!==null && occ!=="")			//If there were some cases,
				{
				for(var k=0;k<occ.length;k++)	//loop through the array items.
					{	
					if (not_done(k))	//If this one hasn't already been done,
						{
						//replace this form of the key by the same form with highlighting.
						txt=txt.replace(new RegExp("\\b"+occ[k]+"\\b", 'g'),hi_pre+occ[k]+hi_post);
						}
					}
				//Store the paragraph	
				paras[j].innerHTML=txt;	//Replace the highlit para. in the section.
				}
			}
			mane.getElementById(prev_s).style.display = "none";		//Hide any previous display,
			
			mane.getElementById(str_s).style.display = "block";		//display the selected section.
			prev_s=str_s;	//Store the code for later clearing.
		}
	}
	
//Routine to check if a particular form of the key has been replaced.
//Parameter:	kk;	the current array subscript.
function not_done(kk)
	{
	var n_d=true			//Set a default return value.
	for(var l=0;l<kk;l++)	//Loop through the occurrence array from the start to the current position less 1.
		{
		if(occ[l]==occ[kk])	//If the same value is found, then it's already been dealt with, so
			{
			n_d=false		//set a False return value.
			}
		}
	return n_d;
	}

//Function remove the highlighting from a section.
function un_lite(sc)
	{
	content=mane.getElementById(sc);	//Store the selected section contents and
	content.innerHTML=content_txt;		//replace the original text.
	}
	
//Function to clear any remaining highlights when the option is closed.
function clear_hilite()
	{
	//alert("A");
	if (prev_s!="v0")	//Check to see if any highlighting has been carried out.
		{
		un_lite(prev_s);	//If so, clear the highlights and
		mane.getElementById(prev_s).style.display = "none";		//hide the display,
		}
	}

