Attribute VB_Name = "db_conv_main"
'Script routine to translate a raw text file into
'a text file holding Javascript array definitions, db[][].
 
'Version;   V1.00,  24/4/2000    Philip Bolt
'Updated:   8/9/11
'Language:  VBscript.

'Converted to a VB project, 30/1/2013
'v2.0

Option Explicit

Public src_nme As String        'Source file name.
Public dest_nme As String       'Destination file name.
Public app_path As String       'Appplication path.
Public str() As String          'Structure text storage.
Public jvs() As String
Public vbs() As String
Public jv_f() As String
Public vb_f() As String
Public r_f() As String          'Record and Field name array

Public canceled As Boolean      'CANCELed flag.

Public cdc As New CDC_class     'Commom Dialog object.

Public Sub get_type()

    Dim j As Integer
    
    ReDim jvs(5), vbs(5), str(5)
        jvs(1) = "db["
        jvs(2) = "]["
        jvs(3) = "]=" + Chr(34)
        jvs(4) = Chr(34) + Chr(59)
        jvs(5) = Chr(34) + Chr(44)
        
        vbs(1) = "db("
        vbs(2) = Chr(44)
        vbs(3) = ")=" + Chr(34)
        vbs(4) = Chr(34)
        vbs(5) = Chr(34) + Chr(58)
        
    ReDim r_d(1), jv_f(1), vb_f(1)
        jv_f(0) = "var num_rec="
        jv_f(1) = "var num_flds="
    
        vb_f(0) = "num_rec="
        vb_f(1) = "num_flds="
        
    If db_convert.Option1(0) Then 'Javascript is selected, so
        str() = jvs()   'Assign the Javascript variable structure.
        r_f() = jv_f()
    Else
        str() = vbs()   'Assign the VBscript variable structure.
        r_f() = vb_f()
    End If
    
    convert
    
End Sub

Public Sub convert()

    Dim r_cnt, f_cnt, pt, vbt_pt, fc As Integer
    Dim dta, txt As String
    Dim rf_t() As String
    Dim sh, dh As Object
    
    app_path = App.Path & "\"   'Store the application directory.
   
    ReDim rf_t(1)   'Dimension the Record/Field array.
    
    src_nme = get_file          'Get a data source file name.
    If Not canceled Then
        dest_nme = "update.txt" 'Store the destination file name.
    
        Open src_nme For Input As #1
            Open dest_nme For Output As #2
    
            r_cnt = 1
            Do
                Line Input #1, dta
                'If Not EOF(1) Then
                    vbt_pt = 1: pt = 1: f_cnt = 0                               'Initialise the pointers and
                    txt = str(1) + CStr(r_cnt) + str(2) + CStr(f_cnt) + str(3)  'create the first part of the array string.
                    Do  'Loop until all the Tabs have been found.
                        f_cnt = f_cnt + 1               'Increment the Field count and
                        vbt_pt = InStr(pt, dta, vbTab)  'find the position of the next Tab
                        If vbt_pt > 0 Then              'If there is a Tab,
                            'create the next part of the array string.
                            txt = txt + Mid(dta, pt, vbt_pt - pt) + str(5) + str(1) + CStr(r_cnt) + str(2) + CStr(f_cnt) + str(3)
                            pt = vbt_pt + 1 'Re-set the start pointer.
                        End If
                    Loop Until vbt_pt = 0
                    txt = txt + Right(dta, Len(dta) - pt + 1) + str(4)  'Add the final part of the array string.
                    Print #2, txt       'Output a line of array data and
                    r_cnt = r_cnt + 1   'increment the Record count.
                'End If
            Loop Until EOF(1)
            
            
            rf_t(0) = r_f(0) + CStr(r_cnt - 1)  'Write the values of the Record number and
            rf_t(1) = r_f(1) + CStr(f_cnt)      'Field number as script variable declarations.
            If db_convert.Option1(0) Then   'this was a Javascriot conversion, so
                rf_t(0) = rf_t(0) + Chr(59) 'add on the trailing semi-colon.
                rf_t(1) = rf_t(1) + Chr(59)
            End If
            
            Print #2, (rf_t(0)) 'Write the values of the Record number and
            Print #2, (rf_t(1))
            
            Close #2   'Close the files.
        Close #1
    End If 'not canceled
    
    'Unload the form to close the package.
    fc = -1
    Do Until fc = 0
        fc = Forms.Count - 1    'Unload all Loaded forms.
        Unload Forms(fc)
    Loop
    
End Sub

'Routine to get text Data file.
'No check is made that the selected file IS a Data file.
'Function name:    get_file

Function get_file()

    Dim flgg As Integer
    Dim hwnd As Long
    Dim ttl, fltr, f_n As String

    ttl = "SELECT A DATA FILE FOR CONVERSION"
    flgg = cdlOFNHideReadOnly Or cdlOFNNoChangeDir Or cdlOFNPathMustExist 'Set up the flags
    fltr = "Text Files (*.txt)" & Chr$(0) & "*.txt" 'Define the filter for Plant files.
    
    f_n = cdc.ShowOpen(db_convert.hwnd, fltr, flgg, ttl, app_path)    'Select the file name.
 
    If Not canceled Then
        get_file = f_n    'Return the full-file path.
    Else
        get_file = ""     'Return an empty string
    End If
 
End Function
