Attribute VB_Name = "im_process"
Option Explicit

Private pt2 As Integer  'The global pointer.
Private ltr As String   'The alphabetic letter.

'Routine to process the data stored in the Excel workbook, index_maker.xls
'Procedure name:    process_list()

Sub process_list()

    Dim j, pt, bpt As Integer

    If Not canceled Then
        Set cur_sht = xlBook.set_sheet(dta1) 'Define the sheet object variable and select the RAW DATA sheet.
 
        pt = 0
        
        Do  'Find the size of the list.
            pt = pt + 1
        Loop Until cur_sht.Cells(pt, 2) = ""     'Find the size of the list.
    
        num_items = pt  'Store the number of items in the list.
        
        Set rnge = xlBook.set_range(dta1, (1), (1), (num_items), (2))   'Select the set of data.
        rnge.Copy
        Set cur_sht = xlBook.set_sheet(dta2)
        cur_sht.Cells(1, 1).Select
        cur_sht.Paste   'Transfer the data into the SORT DATA sheet.
        
        pt = 1: bpt = 2
        Do 'until EOD found
            Do Until cur_sht.Cells(bpt, 1) <> "" Or cur_sht.Cells(bpt, 2) = ""   'loop until a new name is found.
                bpt = bpt + 1
            Loop
            bpt = bpt - 1   'Store the row number of the last blank cell.
            Set rnge = xlBook.set_range(dta2, (pt), (1), (bpt), (1))   'Select the set of data.
            rnge.FillDown
            pt = bpt + 1: bpt = pt + 1 'Re-set the pointers and process the next block.
        Loop Until cur_sht.Cells(pt, 2) = ""
        
        sort_a (1), (1), (pt - 1), (2), (2) 'Sort the items alphabetically by topic.
        
        create_file 'Create the index file.
    End If
    
End Sub

'General routine to sort the currently selected sheet by COLUMN
'Parameters:      r1,c1;      TLC of range      r2,c2;      BRC of range
'                 k_c;        key column

'Procedure name:  sort_a(r1,c1,r2,c2,k_c)
'
Sub sort_a(r1, c1, r2, c2, k_c)

    Dim s_nme As String

    s_nme = xlBook.sheet_name   'Store the sheet name.
    Set rnge = xlBook.set_range((s_nme), (r1), (c1), (r2), (c2))
    
    With rnge
        .Sort Key1:=cur_sht.Cells(r1, k_c), Order1:=xlAscending, header:=xlNo, OrderCustom:=1, MatchCase:=False _
        , Orientation:=xlTopToBottom
    End With
    
End Sub

'Routine to create the index file from the 'strt_text.txt', 'nd_text.txt' files and the topic data
'in the Workbook.
'Procedure name:    create_file()

Sub create_file()

    Dim j, k, pt, s_n, sn As Integer
    Dim in_file, out_file, last_ltr, lln, txt As String
    Dim cpy As Boolean
     
    tabint = indnt   'Set the initial Tab indent value.
    
    Set cur_sht = xlBook.set_sheet(dta2) 'Define the sheet object variable and select the SORT DATA sheet.
    
    in_file = app_path + "strt_text.txt"    'Define the input file name.
    out_file = app_path + "index_itms.htm"

    'START OFF WITH THE strt_text.txt FILE.
     Open out_file For Output As #2
        Open in_file For Input As #1
            Do
                Line Input #1, lln
                If InStr(lln, "DATE") > 0 Then
                    lln = Replace(lln, "DATE", Format(Now(), "dd/m/yyyy"))  'Put in current date.
                End If
                Print #2, lln       'Output a line of data.
            Loop Until EOF(1)
        Close #1   'Close the 'strt_text' file.
       
        last_ltr = last_letter_code 'Store the value of the last letter in the list.
 
        'ADD IN THE TOPIC DATA
        pt2 = 1 'Initialise the global line pointer.
        
        Do  'until  EOD
            'ADD THE LETTER CODE TO THE INDEX FILE
            ltr = Left(cur_sht.Cells(pt2, 2), 1) 'Store the letter of the alphabet for this block.
            If ltr <> last_ltr Then
                Print #2, String(tabint, tb) + lis(0)    'Output a line of standard data, <li>
            Else
                Print #2, String(tabint, tb) + lis(1)   'Output a line of LastChild data, <li>
            End If
            Print #2, String(tabint + 1, tb) + spans(0) + ltr + spans(1) '<span style="font-size:110%;font-weight:bold">ltr</span>
            Print #2, String(tabint + 1, tb) + uls(0)                    '<ul>
            
            tabint = tabint + 2   'Update the Tab indent value.
            
            pt = 1      'Initialise the letter area line pointer.
            
            ReDim topics(6, pt)     'Clear the topics() and
            ReDim siz(pt)           'size arrays by re-dimensioning them.
            
            Do  'until a new letter is found
                'CHECK ALL LINES WITHIN THIS LETTER AREA AND POPULATE THE 'topics()' ARRAY.
                ReDim Preserve topics(6, pt + 1)    'Re-dimention the topics() and
                ReDim Preserve siz(pt + 1)          'size  arrays.
                
                txt = cur_sht.Cells(pt2 + pt - 1, 2)    'Read the topic text and
                split_txt txt, pt, s_n                  'split it into sections.
            
                siz(pt) = s_n   'Store the number of sections for this topic.
                pt = pt + 1     'Increment the line pointer.
            Loop Until Left(cur_sht.Cells(pt2 + pt - 1, 2), 1) <> ltr Or cur_sht.Cells(pt - 1, 1) = ""  'New Index letter found or EOD.
            
            check 1, 1, ltr  'Check the structure of the data with a recursive routine.

            'Add the finishing lines for this block.
            step_left

            pt2 = pt2 + pt - 1 'Update the global line pointer.
        Loop Until cur_sht.Cells(pt2, 1) = ""   'EOD has been reached.
 
        'ADD THE FINAL PART OF THE CODE FROM THE nd_text.txt FILE.
        in_file = app_path + "nd_text.txt"    'Define the input file name.
        Open in_file For Input As #1
            Do
                Line Input #1, lln
                Print #2, lln       'Output a line of data.
            Loop Until EOF(1)
        Close #1   'Close the 'nd_text' file.
     Close #2
     
     close_down 'Close down the package on completion.
     
End Sub

'Routine to find the last letter code in a set of data.
'Function name: last_letter_code()

Function last_letter_code()

    Dim pt As Integer
    
    pt = 1
    Do Until cur_sht.Cells(pt, 1) = ""
        pt = pt + 1
    Loop
    
    last_letter_code = Left(cur_sht.Cells(pt - 1, 2), 1)
    
End Function

'Recursve routine to check the structure of the data,
'Procedure name:    check(s_c, s_r, tc)
'Parameters:        s_c;    the start column,
'                   s_r;    the start row,
'                   tc;     the text, (letter or actual text).

Sub check(s_c, s_r, tc)
     
    Dim l_pt, o_row As Integer
    Dim c_txt, n_txt As String
    Dim l_c As Boolean
   
    l_pt = 0    'Initialise the line pointer offset.
 
    Do 'Loop until the PREVIOUS column text changes.
        c_txt = topics(s_c, s_r + l_pt) 'Store the  topic text and
        o_row = s_r + l_pt              'the originating row value.
        
        Do 'Loop until new text is found in the SPECIFIED column.
            l_pt = l_pt + 1
        Loop Until topics(s_c, s_r + l_pt) <> c_txt
        
        If topics(s_c - 1, s_r + l_pt) <> tc Then 'this is the end of a block, so
            l_c = True  'set the LastChild flag.
        Else            'Otherwise,
            l_c = False 'clear the flag.
        End If
        
        If s_c = siz(o_row) Then 'this is the end of a row, so add the URL text.
            If l_c Then 'this is a LastChild item, so
                add_url_LC s_c, o_row   'add the URL with LastChild notation.
            Else                        'Otherwise,
                add_url s_c, o_row      'just add the URL.
            End If
        Else            'Otherwise, this is a step situation.
            If l_c Then 'this is a LastChild item, so
                step_right_LC s_c, o_row    'step to the right with LastChild notation.
            Else                            'Otherwise,
                step_right s_c, o_row       'just step to the right.
            End If

            check s_c + 1, o_row, c_txt     'Check the next block across recursively and then
            step_left                       'step back to the left.
        End If

    Loop Until topics(s_c - 1, s_r + l_pt) <> tc
    
End Sub

'Routine to add <li> and  <ul>
'Procedure name:    step_right(c, r)
'Parameters:        c;  the column,
'                   r;  the row.

Sub step_right(c, r)

    Print #2, String(tabint, tb) + lis(0)               '<li> preceeded by a set of tabs.
    Print #2, String(tabint + 1, tb) + topics(c, r)     'text
    Print #2, String(tabint + 1, tb) + uls(0)           '<ul>
    
    tabint = tabint + 2     'Update the Tab value.
    
End Sub

'Routine to add <li> with LastChild' notation and  <ul>.
'Procedure name:    step_right_LC(c, r)
'Parameters:        c;  the column,
'                   r;  the row.

Sub step_right_LC(c, r)

    Print #2, String(tabint, tb) + lis(1)               '<li  class = "lastChild">
    Print #2, String(tabint + 1, tb) + topics(c, r)     'text
    Print #2, String(tabint + 1, tb) + uls(0)           '<ul>
    
    tabint = tabint + 2     'Update the Tab value.
    
End Sub

'Routine to add <li>, URL & text and </li> for the end-of-a-line item.
'Procedure name:    add_url(c, r)
'Parameters:        c;  the column,
'                   r;  the row.

Sub add_url(c, r)

    Print #2, String(tabint, tb) + lis(0)       '<li>
    Print #2, String(tabint + 1, tb) + hrefs(0) + cur_sht.Cells(pt2 + r - 1, 1) + hrefs(1) + topics(c, r) + hrefs(2) 'href = etc.
    Print #2, String(tabint, tb) + lis(2)       '</li>

End Sub

'Routine to add <li> with LastChild notation, URL & text and </li> for the end-of-a-line item.
'Procedure name:    add_url_LC(c, r)
'Parameters:        c;  the column,
'                   r;  the row.

Sub add_url_LC(c, r)

    Print #2, String(tabint, tb) + lis(1)       '<li  class = "lastChild">
    Print #2, String(tabint + 1, tb) + hrefs(0) + cur_sht.Cells(pt2 + r - 1, 1) + hrefs(1) + topics(c, r) + hrefs(2) 'href = etc.
    Print #2, String(tabint, tb) + lis(2)       '</li>

End Sub

'Routine to add </li> and </ul> tags.
'Procedure name:    step_left()

Sub step_left()

    Print #2, String(tabint - 1, tb) + uls(1)   '</ul>
    Print #2, String(tabint - 2, tb) + lis(2)   '</li>
    
    tabint = tabint - 2     'Update the Tab value.
                            
End Sub

'Routine to split the topic text into sections on the basis of 'comma' de-limiters.
'Procedure name:    split_txt(tx, p, cnt)
'Parameter:         tx;     the text to be split,
'                   p;      the block array pointer.
'                   cnt;    return for the number of sections.

Sub split_txt(tx, p, cnt)

    Dim strt, nd As Integer
    Dim delim As String
    
    delim = "," 'Store the de-limiter character.
    
    strt = 1    'Initialise the start position,
    nd = 1      'the end position and
    cnt = 1     'the section count.
    
    Do
        nd = InStr(strt, tx, delim)  'Find the occurence of a comma.
        If nd > 0 Then 'there is a comma, so
            topics(cnt, p) = Mid(tx, strt, nd - strt) 'store the section string.
            
            cnt = cnt + 1   'Increment the section count and
            strt = nd + 1   'the start string.
        Else    'All commas done or there weren't any, so
             topics(cnt, p) = Right(tx, Len(tx) - strt + 1) 'store the whole or remaining section string.
        End If
    Loop Until nd = 0
    
    topics(0, p) = ltr  'Store the alpha code in the zeroth position.
    
End Sub
